Motion+
DocsVue

Scroll animation

Scroll-triggered and scroll-linked animations for Vue, via whileInView and useScroll.

There are two types of scroll animations:

  • Scroll-triggered: A normal animation is triggered when an element enters the viewport.

  • Scroll-linked: Values are linked directly to scroll progress.

Motion is capable of both types of animation.

Scroll-triggered animations

Scroll-triggered animations are just normal animations that fire when an element enters or leaves the viewport.

Motion offers the whileInView prop to set an animation target or variant when the element enters the view.

<motion.div
  :initial="{ opacity: 0 }"
  :whileInView="{ opacity: 1 }"
/>
>Live exampleOpen

One-time animations

With the inViewOptions , it's possible to set once: true so once an element has entered the viewport, it won't animate back out.

<motion.div
  initial="hidden"
  whileInView="visible"
  :inViewOptions="{ once: true }"
/>

Changing scroll container

By default, the element will be considered within the viewport when it enters/leaves the window. This can be changed by providing the ref of another scrollable element.

<script setup>
  import { ref } from "vue"
  const scrollRef = ref(null)
</script>

<template>
    <div ref="scrollRef" :style="{ overflow: 'scroll' }">
      <motion.div
        :initial="{ opacity: 0 }"
        :whileInView="{ opacity: 1 }"
        :inViewOptions="{ root: scrollRef }"
      />
    </div>
</template>

For more configuration options, checkout the motion component API reference.

Setting state

It's also possible to set state when any element (not just a motion component) enters and leaves the viewport with the useInView hook.

Scroll-linked animations

Scroll-linked animations are created using motion values and the useScroll hook.

useScroll returns four motion values, two that store scroll offset in pixels (scrollX and scrollY) and two that store scroll progress as a value between 0 and 1.

These motion values can be passed directly to specific styles. For instance, passing scrollYProgress to scaleX works great as a progress bar.

<script>
import { useScroll } from "motion-v"
const { scrollYProgress } = useScroll();
</script>

<template>
  <motion.div :style="{ scaleX: scrollYProgress }" />  
</template>
>Live exampleOpen

Value smoothing

This value can be smoothed by passing it through useSpring.

<script setup>  
const { scrollYProgress } = useScroll();
const scaleX = useSpring(scrollYProgress, {
  stiffness: 100,
  damping: 30,
  restDelta: 0.001
})
</script>

<template>
 <motion.div :style="{ scaleX }" />
</template>

Transform other values

With the useTransform hook, it's easy to use the progress motion values to mix between any value, like colors:

<script setup>  
const backgroundColor = useTransform(
  scrollYProgress,
  [0, 0.5, 1],
  ["#f00", "#0f0", "#00f"]
)
</script>

<template>
  <motion.div :style="{ backgroundColor }" />
</template>

Examples

Track element scroll offset

>Live exampleOpen

Track element within viewport

>Live exampleOpen

Parallax

>Live exampleOpen

Scroll velocity and direction

Read the full useScroll docs to discover more about creating the above effects.

Motion+
DocsReact

React scroll animation

Scroll-triggered and scroll-linked effects in React: parallax, progress, and more.

Learn how to create scroll animations in React with Motion. This guide covers scroll-linked animations, scroll-triggered animations, parallax, horizontal scrolling, and more. All with live examples and copy-paste code.

Types of scroll animation

There are two fundamental types of scroll animations:

  • Scroll-triggered: An animation is triggered when an element enters or leaves the viewport. Common for fade-in effects and lazy-loading.

  • Scroll-linked: Animation values are linked directly to scroll position. Used for parallax, progress bars, and interactive storytelling.

Motion supports both types of scroll animations with simple, performant APIs.

Performance

Motion is the only animation library that runs scroll-linked animations on the browser's native ScrollTimeline where possible, for fully hardware-accelerated animations. Scroll-triggered animations use a pooled IntersectionObserver for minimal overhead.

Scroll-triggered animations

Scroll-triggered animations fire when an element enters or leaves the viewport, or scrolls to a specific point in the viewport.

Motion provides the whileInView prop to set an animation target.

<motion.div
  initial={{ opacity: 0 }}
  whileInView={{ opacity: 1 }}
/>
>Live exampleOpen

Animate once on scroll

By default, elements will animate between initial/animate, and whileInView, as the element enters and leaves the viewport. Via the viewport options, set once: true so an animation only plays the first time an element scrolls into view.

<motion.div
  initial="hidden"
  whileInView="visible"
  viewport={{ once: true }}
/>

Changing scroll container

By default, animations will trigger based on the window viewport. To set a custom scroll container element, pass the ref of another scrollable element to the root option:

function Component() {
  const scrollRef = useRef(null)
  
  return (
    <div ref={scrollRef} style={{ overflow: "scroll" }}>
      <motion.div
        initial={{ opacity: 0 }}
        whileInView={{ opacity: 1 }}
        viewport={{ root: scrollRef }}
      />
    </div>
  )
}

For more configuration options, checkout the motion component API reference.

Setting state

It's also possible to set React state when any element (not just a motion component) enters and leaves the viewport with the useInView hook.

function Component() {
  const ref = useRef(null)
  const isInView = useInView(ref)

  return (
    <div ref={ref}>
      {isInView ? "Hello!" : "Bye..."}
    </div>
  )
}

Scroll-linked animations

Scroll-linked animations connect CSS styles directly to scroll position. In Motion, this is done with the useScroll hook.

useScroll returns four motion values:

  • scrollX/scrollY: Scroll position in pixels

  • scrollXProgress/scrollYProgress: Scroll progress from 0 to 1

Scroll progress bar

Create a reading progress indicator by linking scrollYProgress to scaleX:

const { scrollYProgress } = useScroll();

return (
  <motion.div style={{ scaleX: scrollYProgress, originX: 0 }} />  
)
>Live exampleOpen

Detect scroll direction

It's possible to track scroll direction by using useMotionValueEvent on scrollY. With this, it's possible to animate items to different states, like a menu that only shows as we scroll down.

const { scrollY } = useScroll()
const [scrollDirection, setScrollDirection] = useState("down")

useMotionValueEvent(scrollY, "change", (current) => {
  const diff = current - scrollY.getPrevious()
  setScrollDirection(diff > 0 ? "down" : "up")
})
>Live exampleOpen

Smoothing scroll values

Smooth changes to a scroll value by passing one through useSpring:

const { scrollYProgress } = useScroll();
const scaleX = useSpring(scrollYProgress, {
  stiffness: 100,
  damping: 30,
  restDelta: 0.001
})

return <motion.div style={{ scaleX }} />

Transform scroll position to any value

Use the useTransform hook to map scroll progress to colours, positions, or any other CSS value:

const filter = useTransform(
  scrollYProgress,
  [0, 1],
  ["blur(0px)", "blur(10px)"]
)

return <motion.div style={{ filter }} />
>Live exampleOpen

Track element scroll position through viewport

By default, useScroll progress values will represent the overall viewport scroll (or element scroll).

By passing an element via the target option, scrollYProgress will return its progress through the visible space.

const ref = useRef(null)
const { scrollYProgress } = useScroll({
  target: ref,
  /*
    When the top of the target meets the bottom of the container
    to when the bottom of the target meets the top of the container
  */
  offset: ["start end", "end start"]
})
>Live exampleOpen

Parallax scrolling

Parallax creates the illusion of depth by moving elements at different speeds. Background layers should move slower than foreground layers:

const { foregroundY, backgroundY } = useTransform(
  scrollY,
  [0, 1],
  {
    foregroundY: [0, 2], // move 2px for every 1 scroll px
    backgroundY: [0, 0.5] // move 0.5px for every 1 scroll px
  },
  { clamp: false }
)
>Live exampleOpen

Scroll image reveal effect

By linking clipPath to scrollYProgress, you can have an image "reveal" itself as it scrolls into view.

const ref = useRef(null)
const { scrollYProgress } = useScroll({
  target: ref,
  offset: ["start end", "center center"]
})

const clipPath = useTransform(
  scrollYProgress,
  [0, 1],
  ["inset(0% 50% 0% 50%)", "inset(0% 0% 0% 0%)"]
)

return (
  <motion.div ref={ref} style={{ clipPath }}>
    <img src="/photo.jpg" alt="Revealed image" />
  </motion.div>
)
>Live exampleOpen

Horizontal scroll section

You can make a horizontally-scrolling section by combining useScroll, a tall container section, and a wide position: sticky container.

const containerRef = useRef(null)
const { scrollYProgress } = useScroll({
  target: containerRef,
  offset: ["start start", "end end"]
})

const x = useTransform(scrollYProgress, [0, 1], ["0%", "-75%"])

return (
  <div ref={containerRef} style={{ height: "300vh" }}>
    <div style={{ position: "sticky", top: 0, height: "100vh", overflow: "hidden" }}>
      <motion.div style={{ x, display: "flex", gap: 20 }}>
        {items.map(item => (
          <div key={item.id} style={{ flexShrink: 0, width: 400 }}>
            {item.content}
          </div>
        ))}
      </motion.div>
    </div>
  </div>
)

The container should have a long viewport-relative measurement like 300vh. Increasing this length will make the horizontal scrolling feel slower.

>Live exampleOpen

Text scroll

By combining useScroll with the Motion+ Ticker we can make this popular effect where blocks of text scroll horizontally as the page itself scrolls vertically.

By passing scrollY to useTransform and multiplying it by -1 we get a motion value that moves in the opposite direction to the scroll.

const { scrollY } = useScroll()
const invertScroll = useTransform(() => scrollY.get() * -1)

const lines = [
    { text: "Creative", reverse: false },
    { text: "Design", reverse: true },
    { text: "Motion", reverse: false },
    { text: "Studio", reverse: true },
]
>Live exampleOpen
{lines.map((line, index) => (
  <Ticker
    key={line.text}
    className={`ticker-line ticker-${index}`}
    items={[
      <span className="text-solid">{line.text}</span>,
      <span className="text-outline">{line.text}</span>,
    ]}
    offset={line.reverse ? invertScroll : scrollY}
  />
))}

Examples

Track element scroll offset

>Live exampleOpen

Track element within viewport

3D

Scroll velocity and direction

Read the full useScroll docs to discover more about creating the above effects.

FAQs

Are Motion scroll animations hardware accelerated?

Yes, when possible Motion scroll animations are hardware accelerated. Scroll-linked animations default to the browser's native ScrollTimeline (and soon ViewTimeline) when possible, falling back to JavaScript when necessary. Scroll-triggered animations use a pooled IntersectionObserver for extremely low overhead.

What's the difference between scroll-triggered and scroll-linked animations?

Scroll-triggered animations fire when an element enters or leaves the viewport, think fade-ins and reveal effects. Use whileInView or useInView for these. Scroll-linked animations tie a value directly to scroll position, think parallax and progress bars. Use useScroll for these.

How do I create a parallax effect in React?

Combine useScroll with useTransform to move elements at different speeds relative to scroll position. Pass the target ref of a container, then map scrollYProgress to different y ranges per layer: smaller ranges for background, larger for foreground.

How do I create a horizontal scroll section?

Wrap a wide flex container inside a position: sticky element, inside a tall container (e.g. height: 300vh). Use useScroll to track the tall container's progress, then useTransform to map scrollYProgress to a horizontal x translation. The taller the outer container, the slower the horizontal scroll feels.